## js-of-ocaml 4.0.0

=== benchmarks/Makefile ===
# graphs without precompiled programs:
GRAPHSNOPR = time.pdf time-optim.pdf nativejs.pdf

# graphs with precompiled programs:
GRAPHSPR = size.pdf size-optim.pdf compiletime.pdf

# For full benchs:
all: _perf graphsnopr graphspr _noperf

graphsnopr: _noprecomp $(GRAPHSNOPR)

graphspr: __precomp $(GRAPHSPR)

# For fast benchs:
test: _perf fastrun $(GRAPHS) _noperf

exes= $(wildcard programs/*)

exesnames = $(exes:programs/%=%)

missingsizesml = $(exesnames:%=results/sizes/ml/%)
missingsizes=$(missingsizesml)

missingcompiletimes = $(exesnames:%=results/compiletimes/`hostname`/byte/%) $(exesnames:%=results/compiletimes/`hostname`/opt/%)

RUN=dune exec ./run.exe --
REPORT=dune exec ./report.exe --

.PHONY: $(GRAPHSNOPR:.pdf=.svg) $(GRAPHSPR:.pdf=.svg) size.gpl _noprecomp

# compile with precompiled programs for creating benchs
__precomp:
	mkdir -p build/byte
	ln -sf $(exes:%=../../%) build/byte
	if [ ! -d precomptmp ] ; then $(RUN) -compile ; else cd precomptmp ; find . -type f -exec mv {} ../{} \; ; fi
	rm -rf precomptmp
	touch __precomp

# for running the test we do not want precompiled programs
__run:
	make _noprecomp
	$(RUN) -all
	touch __run

fastrun:
	make _noprecomp
	echo "======================== WARNING: fast benchs!"
	$(RUN) -ffast -all
	touch __run

_noprecomp:
	if [ -f __precomp ] ; \
	then \
	  rm -f __precomp ;\
	  mkdir -p precomptmp/build/byte ;\
	  mkdir -p build ;\
	  mkdir -p results ;\
	  find build -type d -exec mkdir -p precomptmp/{} \; ;\
	  find results -type d -exec mkdir -p precomptmp/{} \; ;\
	  for i in $(exesnames) ; do if [ -f build/byte/$$i ] ; then mv -f build/byte/$$i precomptmp/build/byte/ ; fi ; done ;\
	  for i in $(exesnames) ; do for j in build/*/$$i.js ; do if [ -f $$j ] ; then mv $$j precomptmp/$$j ; fi ; done ; done ;\
	  for i in $(exesnames) ; do for j in results/sizes/js_of_ocaml/*/$$i ; do if [ -f $$j ] ; then mv $$j precomptmp/$$j ; fi ; done ; done ;\
	  for i in $(exesnames) ; do for j in results/sizes/*/$$i ; do if [ -f $$j ] ; then mv $$j precomptmp/$$j ; fi ;done ; done ;\
	fi

__missingcompiletimes:
	mkdir -p results/compiletimes/`hostname`/byte/
	for i in $(missingcompiletimes) ; do if [ ! -f $$i ] ; then echo 0 > $$i ; fi ; done
	touch __missingcompiletimes

__missingsizes: __precomp
	for i in $(missingsizes) ; do if [ ! -f $$i ] ; then echo 0 > $$i ; fi ; done
	if [ -f results/sizes/ml/unison ] ; then echo 828471 > results/sizes/ml/unison ; fi
	if [ -f results/sizes/ml/ocamlc ] ; then echo 800771 > results/sizes/ml/ocamlc ; fi
	if [ -f results/sizes/ml/ocsigen_server ] ; then echo 0 > results/sizes/ml/ocsigen_server ; fi
	if [ -f results/sizes/ml/js_of_ocaml ] ; then echo 171361 > results/sizes/ml/js_of_ocaml ; fi
	if [ -f results/sizes/ml/boulderdash ] ; then echo 12920 > results/sizes/ml/boulderdash ; fi
	if [ -f results/sizes/ml/canvas ] ; then echo 740 > results/sizes/ml/canvas ; fi
	if [ -f results/sizes/ml/cubes ] ; then echo 3773 > results/sizes/ml/cubes ; fi
	if [ -f results/sizes/ml/minesweeper ] ; then echo 7106 > results/sizes/ml/minesweeper ; fi
	if [ -f results/sizes/ml/planet ] ; then echo 16488 > results/sizes/ml/planet ; fi
	if [ -f results/sizes/ml/sudoku ] ; then echo 2837 > results/sizes/ml/sudoku ; fi
	touch __missingsizes

# To generate SVG, we first need to run the benchs,
# then to add data for precompiled programs
time.svg: __run
	$(REPORT) -config report-time.config \
	 -omit binary_trees -omit fannkuch_redux -omit loop \
	 -max 5.5 -svg 7 500 150 -edgecaption -ylabel "Execution time" \
	 > $@

size.svg: size.gpl
	gnuplot < $^ > $@

size.gpl: __run __missingsizes
	$(REPORT) -config report-size.config \
	 -omit binary_trees -omit fannkuch_redux -omit loop \
	 -omit fannkuch_redux_2 \
	 -omit boyer_no_exc -omit kb_no_exc \
	 -append boulderdash \
	 -append canvas \
	 -append cubes \
	 -append minesweeper \
	 -append planet \
	 -append sudoku \
	 -append js_of_ocaml \
	 -append ocsigen_server \
	 -append ocamlc \
	 -append unison \
	 -max 3 -ylabel Size -script \
	 -svg 7 650 150 \
	| perl -pe 'BEGIN{undef $$/;} s/e\nplot/e\nset key at 23.75,1.80\nplot/smg' \
	 > $@

time-optim.svg: __run
	$(REPORT) -config report-time-optim.config \
	 -omit binary_trees -omit fannkuch_redux -omit loop \
	 -omit fannkuch_redux_2 \
	 -max 4 -svg 7 400 150 -edgecaption -ylabel "Execution time" \
	 > $@

size-optim.svg: __run __missingsizes
	$(REPORT) -config report-size-optim.config \
	 -omit binary_trees -omit fannkuch_redux -omit loop  \
	 -omit fannkuch_redux_2 \
	 -omit boyer_no_exc -omit kb_no_exc \
	 -append boulderdash \
	 -append canvas \
	 -append cubes \
	 -append minesweeper \
	 -append planet \
	 -append sudoku \
	 -append js_of_ocaml \
	 -append ocsigen_server \
	 -append ocamlc \
	 -append unison \
	 -max 2.5 -svg 7 650 150 -edgecaption -ylabel Size \
	 > $@

compiletime.svg: __run __precomp __missingcompiletimes
	$(REPORT) -config report-compiletime.config \
	 -omit binary_trees -omit fannkuch_redux -omit loop \
	 -max 2 -svg 7 500 150 -edgecaption -ylabel "Compile time" \
	 > $@

nativejs.svg: __run
	$(REPORT) -config report-nativejs.config \
	 -omit binary_trees -omit fannkuch_redux -omit loop \
	 -max 2.8 -svg 7 200 150 -edgecaption -ylabel "Execution time" \
	 > $@


%.pdf: %.svg
	inkscape -D --export-pdf="$@" -w 210 -h 297 $<

_perf:
	for i in /sys/devices/system/cpu/cpu* ; \
	do \
	if [ -f $$i/cpufreq/scaling_governor ] ; then \
		sudo bash -c "echo performance > $$i/cpufreq/scaling_governor" ; \
	fi ; \
	done

_noperf:
	for i in /sys/devices/system/cpu/cpu* ; \
	do \
	if [ -f $$i/cpufreq/scaling_governor ] ; then \
		sudo bash -c "echo powersave > $$i/cpufreq/scaling_governor" ; \
	fi ; \
	done


clean: _noperf
	rm -rf results build __precomp __run *.svg *.pdf *~ precomptmp __missingsizes __missingcompiletimes

=== debian/changelog ===
js-of-ocaml (4.0.0-2) unstable; urgency=medium

  * Team upload.
  * Add patch for cmdliner 1.1.1 support.
  * Clean empty files.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 29 Jun 2022 10:11:01 +0200

js-of-ocaml (4.0.0-1) unstable; urgency=medium

  * New upstream release
  * Build doc

 -- Stéphane Glondu <glondu@debian.org>  Wed, 02 Mar 2022 13:40:49 +0100

=== debian/control ===
Source: js-of-ocaml
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stéphane Glondu <glondu@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 ocaml,
 ocaml-odoc <!nodoc>,
 ocaml-dune (>= 2.5),
 ocaml-findlib,
 libfindlib-ocaml-dev,
 libgraphics-ocaml-dev,
 libcmdliner-ocaml-dev,
 libppxlib-ocaml-dev (>= 0.15.0),
 libyojson-ocaml-dev,
 libuchar-ocaml-dev,
 liblwt-ocaml-dev,
 liblwt-log-ocaml-dev,
 libtyxml-ocaml-dev (>= 4.3),
 libreactivedata-ocaml-dev (>= 0.2),
 menhir,
 libmenhir-ocaml-dev,
 rsync,
 dh-ocaml
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://ocsigen.org/js_of_ocaml
Vcs-Browser: https://salsa.debian.org/ocaml-team/js-of-ocaml
Vcs-Git: https://salsa.debian.org/ocaml-team/js-of-ocaml.git

Package: js-of-ocaml
Architecture: any
Depends:
 libjs-of-ocaml-dev,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: OCaml bytecode to JavaScript compiler (compiler)
 Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
 it possible to run OCaml programs in a web browser. Its key features
 are the following:
  * the whole language, and most of the standard library are
    supported;
  * the generated code can be used with any web server and browser;
  * you can use a standard installation of OCaml to compile your
    programs. In particular, you do not have to recompile a library to
    use it with Js_of_ocaml. You just have to link your program with a
    specific library to interface with the browser APIs.
 .
 This package contains the compiler itself.

Package: libjs-of-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Breaks: libjs-of-ocaml (<< 1.4)
Replaces: libjs-of-ocaml (<< 1.4)
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: OCaml bytecode to JavaScript compiler (development files)
 Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
 it possible to run OCaml programs in a web browser. Its key features
 are the following:
  * the whole language, and most of the standard library are
    supported;
  * the generated code can be used with any web server and browser;
  * you can use a standard installation of OCaml to compile your
    programs. In particular, you do not have to recompile a library to
    use it with Js_of_ocaml. You just have to link your program with a
    specific library to interface with the browser APIs.
 .
 This package contains development files needed to compile server-side
 (using regular OCaml compiler) and client-side (using Js_of_ocaml)
 programs.

Package: libjs-of-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Breaks: libjs-of-ocaml-dev (<< 1.4)
Replaces: libjs-of-ocaml-dev (<< 1.4)
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: OCaml bytecode to JavaScript compiler (runtime)
 Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
 it possible to run OCaml programs in a web browser. Its key features
 are the following:
  * the whole language, and most of the standard library are
    supported;
  * the generated code can be used with any web server and browser;
  * you can use a standard installation of OCaml to compile your
    programs. In particular, you do not have to recompile a library to
    use it with Js_of_ocaml. You just have to link your program with a
    specific library to interface with the browser APIs.
 .
 This package contains runtime libraries that may be needed by
 server-side programs communicating with clients compiled with
 Js_of_ocaml using JSON.

Package: libjs-of-ocaml-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 libjs-bootstrap,
 ${misc:Depends}
Description: OCaml bytecode to JavaScript compiler (documentation)
 Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
 it possible to run OCaml programs in a web browser.
 .
 This package contains the API reference and examples.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DESTDIR=$(CURDIR)/debian/tmp

include /usr/share/ocaml/ocamlvars.mk

export OCAMLPATH := $(CURDIR)/_tmp$(OCAML_STDLIB_DIR)
export PATH := $(CURDIR)/_tmp/usr/bin:$(PATH)

DUNE_INSTALL := dune install --destdir=$(CURDIR)/_tmp --prefix=/usr --libdir=..$(OCAML_STDLIB_DIR)

%:
	dh $@ --with ocaml

override_dh_auto_clean:
	dh_auto_clean
	rm -rf _tmp

override_dh_auto_build:
	rm -f compiler/tests-jsoo/dune         # makes the build fail on amd64
	rm -f compiler/lib-runtime/tests/dune  # makes the build fail on bytecode architectures
ifeq ($(OCAML_HAVE_OCAMLOPT),no)
	sed -i 's/ native//' compiler/bin-js_of_ocaml/dune
endif
	dune build -p js_of_ocaml-compiler
	$(DUNE_INSTALL) js_of_ocaml-compiler
	dune build -p js_of_ocaml
	$(DUNE_INSTALL) js_of_ocaml
	dune build -p js_of_ocaml-ppx
	$(DUNE_INSTALL) js_of_ocaml-ppx
	dune build -p js_of_ocaml-ppx_deriving_json
	$(DUNE_INSTALL) js_of_ocaml-ppx_deriving_json
	dune build -p js_of_ocaml-lwt
	$(DUNE_INSTALL) js_of_ocaml-lwt
	dune build -p js_of_ocaml-toplevel
	$(DUNE_INSTALL) js_of_ocaml-toplevel
	dune build -p js_of_ocaml-tyxml
	$(DUNE_INSTALL) js_of_ocaml-tyxml
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) doc
endif

override_dh_auto_test:
# Needs ppx-expect

override_dh_auto_install:
	rm -rf debian/tmp
	cp -a _tmp debian/tmp
	for u in js_of_ocaml-compiler js_of_ocaml-ppx js_of_ocaml-ppx_deriving_json js_of_ocaml-lwt js_of_ocaml-toplevel js_of_ocaml-tyxml; do \
	  rm -rf debian/tmp/usr/doc/$$u; \
	done
	rm -f debian/tmp/usr/doc/js_of_ocaml/LICENSE

override_dh_install:
	dh_install
	mkdir -p debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc
	rm -rf debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/api
	rm -rf debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/manual
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	cp -a _build/default/_doc/_html debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/api
	cp -a _build/default/manual debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/manual
	find debian/libjs-of-ocaml-doc -type f -empty -delete
	sed -i \
	  's@href=".*//maxcdn\.bootstrapcdn\.com/bootstrap.*/bootstrap\.min\.css"@href="file:///usr/share/javascript/bootstrap/css/bootstrap.min.css"@g' \
	  debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/manual/files/toplevel/index.html
endif

=== debian/watch ===
version=4
https://github.com/ocsigen/js_of_ocaml/releases .*-([0-9.]+)\.tbz

## js-of-ocaml 5.4.0

=== debian/changelog ===
js-of-ocaml (5.4.0-2build2) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 28 Aug 2023 13:37:34 +0200

js-of-ocaml (5.4.0-2build1) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 20 Aug 2023 09:32:19 +0200

js-of-ocaml (5.4.0-2) unstable; urgency=medium

  * Use ocaml_dune DH buildsystem

 -- Stéphane Glondu <glondu@debian.org>  Mon, 07 Aug 2023 05:22:37 +0200

js-of-ocaml (5.4.0-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sat, 22 Jul 2023 10:58:13 +0200

js-of-ocaml (5.3.0-1) unstable; urgency=medium

  * Team upload.
  * Fix d/watch.
  * Bump standards-version to 4.6.2.
  * Document patches better.
  * New upstream release.
  * Fix compilation with recent dune
  * Add missing depend on sedlex

 -- Julien Puydt <jpuydt@debian.org>  Wed, 05 Jul 2023 10:17:24 +0200

=== debian/watch ===
version=4
https://github.com/ocsigen/js_of_ocaml/tags .*/([0-9.]+)\.tar\.gz

## js-of-ocaml 5.6.0

=== debian/changelog ===
js-of-ocaml (5.6.0-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sun, 18 Feb 2024 11:23:53 +0100

=== debian/control ===
--- 
+++ 
@@ -19,11 +19,12 @@
  liblwt-log-ocaml-dev,
  libtyxml-ocaml-dev (>= 4.3),
  libreactivedata-ocaml-dev (>= 0.2),
+ libsedlex-ocaml-dev,
  menhir,
  libmenhir-ocaml-dev,
  rsync,
- dh-ocaml
-Standards-Version: 4.6.0
+ dh-ocaml (>= 1.2.2)
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://ocsigen.org/js_of_ocaml
 Vcs-Browser: https://salsa.debian.org/ocaml-team/js-of-ocaml

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with ocaml --buildsystem ocaml_dune

override_dh_auto_build:
	rm -f compiler/tests-jsoo/dune         # makes the build fail on amd64
	rm -f compiler/lib-runtime/tests/dune  # makes the build fail on bytecode architectures
ifeq ($(OCAML_HAVE_OCAMLOPT),no)
	sed -i 's/ native//' compiler/bin-js_of_ocaml/dune
endif
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) doc
endif
	dh_auto_build

override_dh_auto_test:
# Needs ppx-expect, ppx-hash, node, Uchar.utf_decode...

override_dh_install:
	dh_install
	mkdir -p debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc
	rm -rf debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/api
	rm -rf debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/manual
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	cp -a doc-dev/api debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/api
	cp -a doc-dev/manual debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/manual
	find debian/libjs-of-ocaml-doc -type f -empty -delete
	sed -i \
	  's@href=".*//maxcdn\.bootstrapcdn\.com/bootstrap.*/bootstrap\.min\.css"@href="file:///usr/share/javascript/bootstrap/css/bootstrap.min.css"@g' \
	  debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/manual/files/toplevel/index.html
endif

## js-of-ocaml 5.8.2

=== debian/changelog ===
js-of-ocaml (5.8.2-2build6) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 18 Sep 2024 12:58:52 +0200

js-of-ocaml (5.8.2-2build5) oracular; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 17 Sep 2024 17:39:38 +0200

js-of-ocaml (5.8.2-2build4) oracular; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 11 Sep 2024 21:47:06 +0200

js-of-ocaml (5.8.2-2build3) oracular; urgency=medium

  * No-change rebuild for OCaml ABIs.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 06 Sep 2024 16:06:07 +0200

js-of-ocaml (5.8.2-2build2) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 13 Aug 2024 10:52:59 +0200

js-of-ocaml (5.8.2-2build1) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 09 Aug 2024 14:34:50 +0200

js-of-ocaml (5.8.2-2) unstable; urgency=medium

  * Build doc only on indep builds

 -- Stéphane Glondu <glondu@debian.org>  Sat, 15 Jun 2024 07:39:29 +0200

js-of-ocaml (5.8.2-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 04 Jun 2024 06:50:53 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,6 @@
 Build-Depends:
  debhelper-compat (= 13),
  ocaml,
- ocaml-odoc <!nodoc>,
  ocaml-dune (>= 2.5),
  ocaml-findlib,
  libfindlib-ocaml-dev,
@@ -17,13 +16,15 @@
  libuchar-ocaml-dev,
  liblwt-ocaml-dev,
  liblwt-log-ocaml-dev,
- libtyxml-ocaml-dev (>= 4.3),
+ libtyxml-ocaml-dev (>= 4.6),
  libreactivedata-ocaml-dev (>= 0.2),
  libsedlex-ocaml-dev,
  menhir,
  libmenhir-ocaml-dev,
  rsync,
  dh-ocaml (>= 1.2.2)
+Build-Depends-Indep:
+ ocaml-odoc <!nodoc>
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://ocsigen.org/js_of_ocaml

## js-of-ocaml 5.9.1

=== Makefile ===
all:
	dune build @all

tests:
	dune runtest

test runtest runtests: tests

doc:
	rm -rf doc-dev
	mkdir doc-dev
	dune clean
	dune build @doc --cache=disabled --force
	rsync -av --delete _build/default/_doc/_html/ doc-dev/api
	dune build @doc-manual --cache=disabled --force
	rsync -av --delete --exclude=".*" _build/default/manual/ doc-dev/manual
	find doc-dev/ -name dune -delete
	find doc-dev/ -name "*.exe" -delete

promote:
	dune promote

fmt:
	dune build @fmt --auto-promote 2> /dev/null || true
	git diff --exit-code

clean:
	dune clean

installdoc:
	git worktree add _wikidoc origin/wikidoc
	rsync -av doc-dev/ _wikidoc/doc/dev/

.PHONY: all tests test runtest runtests doc clean installdoc

=== benchmarks/Makefile ===
# graphs without precompiled programs:
GRAPHSNOPR = time.pdf time-optim.pdf nativejs.pdf

# graphs with precompiled programs:
GRAPHSPR = size.pdf size-optim.pdf compiletime.pdf

# graphs showing the impact of supporting effects
GRAPHSEFF = time-effects.pdf size-effects.pdf size-bzip2-effects.pdf

# For full benchs:
all: _perf graphsnopr graphspr graphseff _noperf

graphsnopr: _noprecomp $(GRAPHSNOPR)

graphspr: __precomp $(GRAPHSPR)

graphseff: __precomp $(GRAPHSEFF)

# For fast benchs:
test: _perf fastrun $(GRAPHS) _noperf

exes= $(wildcard programs/*)

exesnames = $(exes:programs/%=%)

missingsizesml = $(exesnames:%=results/sizes/ml/%)
missingsizes=$(missingsizesml)

missingcompiletimes = $(exesnames:%=results/compiletimes/`hostname`/byte/%) $(exesnames:%=results/compiletimes/`hostname`/opt/%)

RUN=dune exec ./run.exe --
REPORT=dune exec ./report.exe --

.PHONY: $(GRAPHSNOPR:.pdf=.svg) $(GRAPHSPR:.pdf=.svg) size.gpl _noprecomp

# compile with precompiled programs for creating benchs
__precomp:
	mkdir -p build/byte
	ln -sf $(exes:%=../../%) build/byte
	if [ ! -d precomptmp ] ; then $(RUN) -compile ; else cd precomptmp ; find . -type f -exec mv {} ../{} \; ; fi
	rm -rf precomptmp
	touch __precomp

# for running the test we do not want precompiled programs
__run:
	make _noprecomp
	$(RUN) -all
	touch __run

__run_effects:
	$(RUN) -fast -nobyteopt -effects
	touch __run_effects

fastrun:
	make _noprecomp
	echo "======================== WARNING: fast benchs!"
	$(RUN) -ffast -all
	touch __run

_noprecomp:
	if [ -f __precomp ] ; \
	then \
	  rm -f __precomp ;\
	  mkdir -p precomptmp/build/byte ;\
	  mkdir -p build ;\
	  mkdir -p results ;\
	  find build -type d -exec mkdir -p precomptmp/{} \; ;\
	  find results -type d -exec mkdir -p precomptmp/{} \; ;\
	  for i in $(exesnames) ; do if [ -f build/byte/$$i ] ; then mv -f build/byte/$$i precomptmp/build/byte/ ; fi ; done ;\
	  for i in $(exesnames) ; do for j in build/*/$$i.js ; do if [ -f $$j ] ; then mv $$j precomptmp/$$j ; fi ; done ; done ;\
	  for i in $(exesnames) ; do for j in results/sizes/js_of_ocaml/*/$$i ; do if [ -f $$j ] ; then mv $$j precomptmp/$$j ; fi ; done ; done ;\
	  for i in $(exesnames) ; do for j in results/sizes/*/$$i ; do if [ -f $$j ] ; then mv $$j precomptmp/$$j ; fi ;done ; done ;\
	fi

__missingcompiletimes:
	mkdir -p results/compiletimes/`hostname`/byte/
	for i in $(missingcompiletimes) ; do if [ ! -f $$i ] ; then echo 0 > $$i ; fi ; done
	touch __missingcompiletimes

__missingsizes: __precomp
	for i in $(missingsizes) ; do if [ ! -f $$i ] ; then echo 0 > $$i ; fi ; done
	if [ ! -f results/sizes/ml/ocamlc ] ; then echo 800771 > results/sizes/ml/ocamlc ; fi
	if [ ! -f results/sizes/ml/js_of_ocaml ] ; then echo 171361 > results/sizes/ml/js_of_ocaml ; fi
	if [ ! -f results/sizes/ml/boulderdash ] ; then echo 12920 > results/sizes/ml/boulderdash ; fi
	if [ ! -f results/sizes/ml/cubes ] ; then echo 3773 > results/sizes/ml/cubes ; fi
	if [ ! -f results/sizes/ml/minesweeper ] ; then echo 7106 > results/sizes/ml/minesweeper ; fi
	if [ ! -f results/sizes/ml/planet ] ; then echo 16488 > results/sizes/ml/planet ; fi
	touch __missingsizes

# To generate SVG, we first need to run the benchs,
# then to add data for precompiled programs
time.svg: __run
	$(REPORT) -config report-time.config \
	 -omit binary_trees \
	 -omit fannkuch_redux \
	 -omit loop \
	 -max 5.5 -svg 7 500 150 -edgecaption -ylabel "Execution time" \
	 > $@

size.svg: size.gpl
	gnuplot < $^ > $@

size.gpl: __run __missingsizes
	$(REPORT) -config report-size.config \
	 -omit binary_trees \
	 -omit fannkuch_redux \
	 -omit fannkuch_redux_2 \
	 -omit boyer_no_exc \
	 -omit kb_no_exc \
	 -omit loop \
	 -append boulderdash \
	 -append cubes \
	 -append minesweeper \
	 -append planet \
	 -append js_of_ocaml \
	 -append ocamlc \
	 -max 4.5 -ylabel Size -script \
	 -svg 7 650 150 \
	| perl -pe 'BEGIN{undef $$/;} s/e\nplot/e\nset key at 19.83,2.87\nplot/smg' \
	 > $@
# You'll need to adjust the perl invocation above to align the "Generated code" caption


time-optim.svg: __run
	$(REPORT) -config report-time-optim.config \
	 -omit binary_trees \
	 -omit fannkuch_redux \
	 -omit fannkuch_redux_2 \
	 -omit loop \
	 -max 2.5 -svg 7 400 150 -edgecaption -ylabel "Execution time" \
	 > $@

size-optim.svg: __run __missingsizes
	$(REPORT) -config report-size-optim.config \
	 -omit binary_trees \
	 -omit fannkuch_redux \
	 -omit fannkuch_redux_2 \
	 -omit boyer_no_exc \
	 -omit kb_no_exc \
	 -omit loop \
	 -append boulderdash \
	 -append cubes \
	 -append minesweeper \
	 -append planet \
	 -append js_of_ocaml \
	 -append ocamlc \
	 -max 2.5 -svg 7 650 150 -edgecaption -ylabel Size \
	 > $@

time-effects.svg: __run_effects
	$(REPORT) -config report-time-effects.config \
	 -omit binary_trees \
	 -omit fannkuch_redux \
	 -omit fannkuch_redux_2 \
	 -omit loop \
	 -omit boulderdash \
	 -omit cubes \
	 -omit minesweeper \
	 -omit planet \
	 -omit ocamlc \
	 -min 0.5 -max 1.5 -svg 7 400 150 -edgecaption -ylabel "Execution time" \
	 > $@

size-effects.svg: __run_effects
	$(REPORT) -config report-size-effects.config \
	 -omit binary_trees \
	 -omit fannkuch_redux \
	 -omit fannkuch_redux_2 \
	 -omit boyer_no_exc \
	 -omit kb_no_exc \
	 -omit loop \
	 -append boulderdash \
	 -append cubes \
	 -append minesweeper \
	 -append planet \
	 -append js_of_ocaml \
	 -append ocamlc \
	 -min 0.8 -max 1.25 -svg 7 650 150 -edgecaption -ylabel Size \
	 > $@

size-gzipped-effects.svg: __run_effects
	$(REPORT) -config report-size-gzipped-effects.config \
	 -omit binary_trees \
	 -omit fannkuch_redux \
	 -omit fannkuch_redux_2 \
	 -omit boyer_no_exc \
	 -omit kb_no_exc \
	 -omit loop \
	 -append boulderdash \
	 -append cubes \
	 -append minesweeper \
	 -append planet \
	 -append js_of_ocaml \
	 -append ocamlc \
	 -max 1.2 -min 0.8 -svg 7 650 150 -edgecaption -ylabel Size \
	 > $@

size-bzip2-effects.svg: __run_effects
	$(REPORT) -config report-size-bzip2-effects.config \
	 -omit binary_trees \
	 -omit fannkuch_redux \
	 -omit fannkuch_redux_2 \
	 -omit boyer_no_exc \
	 -omit kb_no_exc \
	 -omit loop \
	 -append boulderdash \
	 -append cubes \
	 -append minesweeper \
	 -append planet \
	 -append js_of_ocaml \
	 -append ocamlc \
	 -max 1.1 -min 0.95 -svg 7 650 150 -edgecaption -ylabel Size \
	 > $@

compiletime.svg: __run __precomp __missingcompiletimes
	$(REPORT) -config report-compiletime.config \
	 -omit binary_trees \
	 -omit fannkuch_redux \
	 -omit loop \
	 -max 2 -svg 7 500 150 -edgecaption -ylabel "Compile time" \
	 > $@

nativejs.svg: __run
	$(REPORT) -config report-nativejs.config \
	 -omit binary_trees \
	 -omit fannkuch_redux \
	 -omit loop \
	 -max 2.8 -svg 7 200 150 -edgecaption -ylabel "Execution time" \
	 > $@


%.pdf: %.svg
	inkscape -D --export-type="pdf" --export-filename="$@" -w 210 -h 297 $<


nativejs.png: nativejs.svg
	inkscape -D -o "$@" -w 500 $<

%.png: %.svg
	inkscape -D -o "$@" -w 1024 $<

_perf:
	for i in /sys/devices/system/cpu/cpu* ; \
	do \
	if [ -f $$i/cpufreq/scaling_governor ] ; then \
		sudo bash -c "echo performance > $$i/cpufreq/scaling_governor" ; \
	fi ; \
	done

_noperf:
	for i in /sys/devices/system/cpu/cpu* ; \
	do \
	if [ -f $$i/cpufreq/scaling_governor ] ; then \
		sudo bash -c "echo powersave > $$i/cpufreq/scaling_governor" ; \
	fi ; \
	done


clean: _noperf
	rm -rf results build __precomp __run __run_effects *.svg *.pdf *~ precomptmp __missingsizes __missingcompiletimes


copy-extra-bc:
	mkdir -p programs
	dune exec ./stripdebug.exe -- $(shell which ocamlc.byte) programs/ocamlc
	dune build --profile bench_no_debug ../compiler/bin-js_of_ocaml/js_of_ocaml.bc ../examples/
	cp -f ../_build/default/compiler/bin-js_of_ocaml/js_of_ocaml.bc programs/js_of_ocaml
	cp -f ../_build/default/examples/boulderdash/boulderdash.bc programs/boulderdash
	cp -f ../_build/default/examples/cubes/cubes.bc programs/cubes
	cp -f ../_build/default/examples/minesweeper/main.bc programs/minesweeper
	cp -f ../_build/default/examples/planet/planet.bc programs/planet

=== debian/changelog ===
js-of-ocaml (5.9.1-1build8) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 30 Aug 2025 09:47:14 +0200

js-of-ocaml (5.9.1-1build7) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 17 Jun 2025 05:20:24 +0200

js-of-ocaml (5.9.1-1build6) questing; urgency=medium

  * Rebuild against latest ocaml libraries

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 06 May 2025 07:41:01 -0400

js-of-ocaml (5.9.1-1build5) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 13 Feb 2025 23:52:25 +0100

js-of-ocaml (5.9.1-1build4) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 12 Feb 2025 21:27:48 +0100

js-of-ocaml (5.9.1-1build3) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 29 Jan 2025 22:50:28 +0100

js-of-ocaml (5.9.1-1build2) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 23 Jan 2025 09:17:49 +0100

js-of-ocaml (5.9.1-1build1) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 02 Jan 2025 18:02:08 +0100

js-of-ocaml (5.9.1-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 31 Dec 2024 19:54:33 +0100

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
  liblwt-log-ocaml-dev,
  libtyxml-ocaml-dev (>= 4.6),
  libreactivedata-ocaml-dev (>= 0.2),
- libsedlex-ocaml-dev,
+ libsedlex-ocaml-dev (>= 3.3),
  menhir,
  libmenhir-ocaml-dev,
  rsync,

## js-of-ocaml 6.2.0

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,10 @@
 	dune build @all
 
 tests:
-	dune runtest
+	dune build @runtest @runtest-js
+
+tests-wasm:
+	WASM_OF_OCAML=true dune build @runtest-wasm
 
 test runtest runtests: tests
 
@@ -24,6 +27,12 @@
 	dune build @fmt --auto-promote 2> /dev/null || true
 	git diff --exit-code
 
+fmt-js:
+	npx @biomejs/biome@1.9 format --write
+
+lint-js:
+	npx @biomejs/biome@1.9 lint
+
 clean:
 	dune clean
 
@@ -31,4 +40,7 @@
 	git worktree add _wikidoc origin/wikidoc
 	rsync -av doc-dev/ _wikidoc/doc/dev/
 
-.PHONY: all tests test runtest runtests doc clean installdoc
+bench:
+	$(MAKE) -C benchmarks bench
+
+.PHONY: all tests tests-wasm test runtest runtests doc clean installdoc bench

=== benchmarks/Makefile ===
--- 
+++ 
@@ -9,6 +9,31 @@
 
 # For full benchs:
 all: _perf graphsnopr graphspr graphseff _noperf
+
+# This target is the one run by `current-bench`,
+# see https://github.com/ocurrent/current-bench
+.PHONY: bench microbenchmarks
+bench:
+	@date -u +"%FT%TZ - Installing dependencies"
+	opam pin -yn --with-version=dev ..
+	opam install -y wasm_of_ocaml-compiler js_of_ocaml-ppx gen_js_api brr
+	$(MAKE) microbenchmarks
+	$(MAKE) -C benchmark-fiat-crypto bench
+	$(MAKE) -C benchmark-ocamlc bench
+	$(MAKE) -C benchmark-partial-render-table bench
+	$(MAKE) -C benchmark-camlboy bench
+	$(MAKE) -C benchmark-others bench
+
+microbenchmarks:
+	@date -u +"%FT%TZ - Microbenchmarks: starting"
+	make _noprecomp
+	@date -u +"%FT%TZ - Microbenchmarks: compiler"
+	$(RUN) ./report-wasm-cb.config ./report-jsoo-cb.config
+	$(REPORT) -format current-bench -config report-wasm-cb.config \
+	  -ylabel "Wasm_of_ocaml" | sh utils/aggregate.sh wasm
+	$(REPORT) -format current-bench -config report-jsoo-cb.config \
+	  -ylabel "Js_of_ocaml" | sh utils/aggregate.sh js
+	@date -u +"%FT%TZ - Microbenchmarks: done"
 
 graphsnopr: _noprecomp $(GRAPHSNOPR)
 
@@ -48,7 +73,7 @@
 	touch __run
 
 __run_effects:
-	$(RUN) -fast -nobyteopt -effects
+	$(RUN) -fast report-time-effects.config
 	touch __run_effects
 
 fastrun:

=== benchmarks/benchmark-camlboy/Makefile ===
.PHONY: bench perform

export NAME=Camlboy

SHELL=/bin/bash -o pipefail

DIR=CAMLBOY
SCRIPT=$(DIR)/_build/default/bin/web/bench_node.bc
ROM=$(DIR)/resource/games/tobu.gb

bench:
	@date -u +"%FT%TZ - $(NAME): starting"
	git clone --depth 1 https://github.com/ocaml-wasm/CAMLBOY -b node
	cd $(DIR) && opam exec -- dune build --root . --profile release ./bin/web
	@date -u +"%FT%TZ - $(NAME): compiled"
	$(MAKE) perform COMPILER=Js_of_ocaml SUFFIX=.js KIND=js
	$(MAKE) perform COMPILER=Wasm_of_ocaml SUFFIX=.wasm.js KIND=wasm
	@date -u +"%FT%TZ - $(NAME): done"

perform:
	node $(SCRIPT)$(SUFFIX) $(ROM) | \
	tee /dev/stderr | \
	ocaml output_results.ml $(COMPILER) | \
	sh ../utils/aggregate.sh $(KIND)

=== benchmarks/benchmark-fiat-crypto/Makefile ===
.PHONY: bench perform

export NAME=Fiat-Crypto

SHELL=/bin/bash -o pipefail

bench:
	@date -u +"%FT%TZ - $(NAME): starting"
	$(MAKE) perform COMPILER=js_of_ocaml EXTRA_ARGS="--effects cps" KIND=js
	$(MAKE) perform COMPILER=wasm_of_ocaml EXTRA_ARGS="" KIND=wasm
	@date -u +"%FT%TZ - $(NAME): done"

perform: bedrock2_fiat_crypto.byte
	/usr/bin/time -f "%E %R" $(COMPILER) --debug times --source-map $(EXTRA_ARGS) $< -o out.js 2>&1 | \
	ocaml -I +str str.cma ../utils/compilation_metrics.ml $(COMPILER) $(NAME) out.js | \
	sh ../utils/aggregate.sh $(KIND)

bedrock2_fiat_crypto.byte: bedrock2_fiat_crypto.ml
	ocamlfind ocamlc -w -20 -g -linkpkg -package js_of_ocaml -g $< -o $@

bedrock2_fiat_crypto.ml: bedrock2_fiat_crypto.ml.xz
	unxz --keep $<

=== benchmarks/benchmark-ocamlc/Makefile ===
.PHONY: bench perform

export NAME=Ocamlc

SHELL=/bin/bash -o pipefail

bench:
	@date -u +"%FT%TZ - $(NAME): starting"
	cp -r ../sources/ml .
	$(MAKE) perform COMPILER=js_of_ocaml SCRIPT=ocamlc.js KIND=js
	$(MAKE) perform COMPILER=wasm_of_ocaml SCRIPT=ocamlc.wasm.js KIND=wasm
	@date -u +"%FT%TZ - $(NAME): done"

ARGS=ml/*.ml ml/*.ml ml/*.ml ml/*.ml ml/*.ml ml/*.ml ml/*.ml ml/*.ml

perform:
	/usr/bin/time -f "%E %R" $(COMPILER) --debug times --opt 2 --pretty `which ocamlc.byte` -o $(SCRIPT) 2>&1 | \
	ocaml -I +str str.cma ../utils/compilation_metrics.ml $(COMPILER) $(NAME) $(SCRIPT) | \
	sh ../utils/aggregate.sh $(KIND)
	/usr/bin/time -f '{"compiler": "$(COMPILER)", "time":"%E"}' node $(SCRIPT) -c $(ARGS) 2>&1 | \
	sh ../utils/format_metrics.sh exec | \
	sh ../utils/aggregate.sh $(KIND)

=== benchmarks/benchmark-others/Makefile ===
SUBDIRS := $(wildcard */.)

bench: $(SUBDIRS)

$(SUBDIRS):
	$(MAKE) -C $@

.PHONY: all $(SUBDIRS)

=== benchmarks/benchmark-partial-render-table/Makefile ===
.PHONY: bench perform

export NAME=Partial Render Table

SHELL=/bin/bash -o pipefail

bench:
	@date -u +"%FT%TZ - $(NAME): starting"
	dune build --root ../../../janestreet --profile release lib/bonsai_web_components/partial_render_table/bench/bin/main.bc.wasm.js lib/bonsai_web_components/partial_render_table/bench/bin/main.bc.js
	cp -r ../../../janestreet/_build/default/lib/bonsai_web_components/partial_render_table/bench/bin/main.bc* .
	@date -u +"%FT%TZ - $(NAME): compiled"
	$(MAKE) perform COMPILER=js_of_ocaml SCRIPT=main.bc.js KIND=js
	$(MAKE) perform COMPILER=wasm_of_ocaml SCRIPT=main.bc.wasm.js KIND=wasm
	@date -u +"%FT%TZ - $(NAME): done"

perform:
	/usr/bin/time -f "%E %R" $(COMPILER) --debug times --opt 2 --pretty main.bc-for-jsoo -o out.js 2>&1 | \
	tee /dev/stderr | \
	ocaml -I +str str.cma ../utils/compilation_metrics.ml $(COMPILER) "$(NAME)" out.js | \
	sh ../utils/aggregate.sh $(KIND)
	node $(SCRIPT) | \
	tee /dev/stderr | \
	ocaml -I +str str.cma summarize_results.ml $(COMPILER) | \
	sh ../utils/aggregate.sh $(KIND)

=== benchmarks/benchmark-others/bigarrays/Makefile ===
.PHONY: bench perform

export NAME=Others
export SUBNAME=bigarrays

SHELL=/bin/bash -o pipefail

bench:
	@date -u +"%FT%TZ - $(NAME)/$(SUBNAME): starting"
	ocamlc bench.ml -o bench
	$(MAKE) perform COMPILER=js_of_ocaml SCRIPT=bench.js KIND=js
	$(MAKE) perform COMPILER=wasm_of_ocaml SCRIPT=bench.wasm.js KIND=wasm
	@date -u +"%FT%TZ - $(NAME)/$(SUBNAME): done"

perform:
	$(COMPILER) --opt 2 --pretty bench -o $(SCRIPT)
	/usr/bin/time -f '{"compiler": "$(COMPILER)", "time":"%E"}' node $(SCRIPT) 2>&1 | \
	sh ../../utils/format_metrics.sh exec | \
	sh ../../utils/aggregate.sh $(KIND)

=== benchmarks/benchmark-others/bin_prot/Makefile ===
.PHONY: bench perform

export NAME=Others
export SUBNAME=bin_prot

SHELL=/bin/bash -o pipefail

bench:
	@date -u +"%FT%TZ - $(NAME)/$(SUBNAME): starting"
	dune build --profile release --root .
	node _build/default/bench.bc.js 400000
	$(MAKE) perform COMPILER=js_of_ocaml SCRIPT=_build/default/bench.bc.js KIND=js
	$(MAKE) perform COMPILER=wasm_of_ocaml SCRIPT=_build/default/bench.bc.wasm.js KIND=wasm
	@date -u +"%FT%TZ - $(NAME)/$(SUBNAME): done"

perform:
	/usr/bin/time -f '{"compiler": "$(COMPILER)", "time":"%E"}' node $(SCRIPT) 2>&1 1> /dev/null | \
	tee /dev/stderr | \
	sh ../../utils/format_metrics.sh exec | \
	sh ../../utils/aggregate.sh $(KIND)

=== benchmarks/benchmark-others/lexifi-g2pp/Makefile ===
.PHONY: bench perform

export NAME=Others
export SUBNAME=lexifi-g2pp

SHELL=/bin/bash -o pipefail

bench:
	@date -u +"%FT%TZ - $(NAME)/$(SUBNAME): starting"
	dune build --profile release --root .
	$(MAKE) perform COMPILER=js_of_ocaml SCRIPT=_build/default/main.bc.js KIND=js
	$(MAKE) perform COMPILER=wasm_of_ocaml SCRIPT=_build/default/main.bc.wasm.js KIND=wasm
	@date -u +"%FT%TZ - $(NAME)/$(SUBNAME): done"

perform:
	/usr/bin/time -f '{"compiler": "$(COMPILER)", "time":"%E"}' node $(SCRIPT) 2>&1 1> /dev/null | \
	sh ../../utils/format_metrics.sh exec | \
	sh ../../utils/aggregate.sh $(KIND)

=== debian/changelog ===
js-of-ocaml (6.2.0-2build2) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 22 Oct 2025 07:37:08 +0200

js-of-ocaml (6.2.0-2build1) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 20 Oct 2025 14:44:35 +0200

js-of-ocaml (6.2.0-2) unstable; urgency=medium

  * Add version constraint in libjs-of-ocaml-dev dependency

 -- Stéphane Glondu <glondu@debian.org>  Mon, 15 Sep 2025 11:37:21 +0200

js-of-ocaml (6.2.0-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.7.2

 -- Stéphane Glondu <glondu@debian.org>  Thu, 11 Sep 2025 07:49:30 +0200

=== debian/control ===
--- 
+++ 
@@ -25,7 +25,7 @@
  dh-ocaml (>= 1.2.2)
 Build-Depends-Indep:
  ocaml-odoc <!nodoc>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://ocsigen.org/js_of_ocaml
 Vcs-Browser: https://salsa.debian.org/ocaml-team/js-of-ocaml
@@ -34,7 +34,7 @@
 Package: js-of-ocaml
 Architecture: any
 Depends:
- libjs-of-ocaml-dev,
+ libjs-of-ocaml-dev (= ${binary:Version}),
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -6,22 +6,22 @@
 %:
 	dh $@ --with ocaml --buildsystem ocaml_dune
 
-override_dh_auto_build:
+execute_before_dh_auto_build:
 	rm -f compiler/tests-jsoo/dune         # makes the build fail on amd64
 	rm -f compiler/lib-runtime/tests/dune  # makes the build fail on bytecode architectures
 ifeq ($(OCAML_HAVE_OCAMLOPT),no)
 	sed -i 's/ native//' compiler/bin-js_of_ocaml/dune
 endif
 ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
+ifneq (,$(filter libjs-of-ocaml-doc,$(shell dh_listpackages)))
 	$(MAKE) doc
 endif
-	dh_auto_build
+endif
 
 override_dh_auto_test:
 # Needs ppx-expect, ppx-hash, node, Uchar.utf_decode...
 
-override_dh_install:
-	dh_install
+execute_after_dh_install-indep:
 	mkdir -p debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc
 	rm -rf debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/api
 	rm -rf debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/manual
